Bug 844492 - LVM RAID: Support 2-way mirror RAID10
Summary: LVM RAID: Support 2-way mirror RAID10
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: lvm2
Version: 6.3
Hardware: Unspecified
OS: Unspecified
high
low
Target Milestone: rc
: ---
Assignee: Jonathan Earl Brassow
QA Contact: Cluster QE
URL:
Whiteboard:
Depends On: 886658 889358
Blocks: 857209
TreeView+ depends on / blocked
 
Reported: 2012-07-30 22:10 UTC by Jonathan Earl Brassow
Modified: 2018-11-30 22:58 UTC (History)
12 users (show)

Fixed In Version: lvm2-2.02.98-1.el6
Doc Type: Release Note
Doc Text:
LVM Support for 2-way Mirror RAID10 LVM is now capable of creating, removing, and resizing RAID10 logical volumes. To create a RAID10 logical volume, like the other RAID types, specify the segment type as follows: ~]# lvcreate --type raid10 -m 1 -i 2 -L 1G -n lv vg Note that the -m and -i arguments behave in the same way they would for other segment types. That is, -i is the total number of stripes while -m is the number of (additional) copies (that is, -m 1 -i 2 gives 2 stripes on top of 2-way mirrors).
Clone Of:
: 857209 (view as bug list)
Environment:
Last Closed: 2013-02-21 08:13:08 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2013:0501 normal SHIPPED_LIVE lvm2 bug fix and enhancement update 2013-02-20 21:30:45 UTC

Description Jonathan Earl Brassow 2012-07-30 22:10:53 UTC
MD has the capability to do RAID10.  This is not simply stacking one segment type upon another - it is an integrated system that allows for many RAID10-like permutations.

This bug is a feature request for LVM to support the most basic variant of RAID10 - striped 2-way mirrors.

Comment 1 Jonathan Earl Brassow 2012-07-30 22:13:49 UTC
TEST REQUIREMENTS:

Simply put, perform all the tests on a RAID10 LV that are performed on a RAID1 or RAID4/5/6 LV.  This includes, but shouldn't be limited to:
1) Create RAID10 LV
2) Remove RAID10 LV
3) Resize RAID10 LV
4) Data consistency checking
5) Device failure testing

Comment 3 Corey Marthaler 2012-08-01 15:29:07 UTC
Adding QA ack for 6.4. 

Devel will need to provide unit testing results however before this bug can be
ultimately verified by QA.

Comment 4 Jonathan Earl Brassow 2012-09-04 16:16:33 UTC
LVM test suite passes with the following changes made to test this new feature:

- creation of RAID10 LVs  [lvcreate-raid.sh]
-- does not allow more than 2-way mirror
-- does allow more than 2-way stripe

- replacement of devices  [lvconvert-raid.sh]
-- replacement of any single device succeeds (while in-sync)
-- replacement of more than 1 dev in a mirror group fails
-- replacement of 1 dev from each mirror group will succeed

- resize LV [lvresize-raid.sh]
-- extend LV
-- reduce LV


For consistency testing, I only made a file system on the LV, mounted it, and did kernel untars and removals.

Comment 5 Jonathan Earl Brassow 2012-09-04 21:52:04 UTC
commit 4047e4dfb16175daec348bf44032c02181bd4c70
Author: Jonathan Brassow <jbrassow@redhat.com>
Date:   Fri Aug 24 15:34:19 2012 -0500

    RAID:  Add support for RAID10
    
    This patch adds support for RAID10.  It is not the default at this
    stage.  The user needs to specify '--type raid10' if they would like
    RAID10 instead of stacked mirror over stripe.

Comment 11 Nenad Peric 2013-01-22 10:17:32 UTC
Ran both black_bird and raid_sanity test for 3 iterations without issues. 

I am marking this as verified even though there are some hickups with the whole mirrored stripe leg failuire of raid10 (which effectively kills raid10, as expected but could maybe be 'more graceful').


Verified with:

lvm2-2.02.98-8.el6.x86_64
lvm2-libs-2.02.98-8.el6.x86_64
lvm2-cluster-2.02.98-8.el6.x86_64
device-mapper-1.02.77-8.el6.x86_64
udev-147-2.45.el6.x86_64
kernel-2.6.32-354.el6.x86_64

Comment 12 errata-xmlrpc 2013-02-21 08:13:08 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHBA-2013-0501.html


Note You need to log in before you can comment on or make changes to this bug.